import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeEvery } from 'redux-saga/effects';

import AppContext from '@loafer/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import * as AsyncRequestActions from '../action/asyncRequest';
import AsyncRequestPayload from '../payload/AsyncRequestPayload';

function* request(action: Action<AsyncRequestPayload>): SagaIterator {
  try {
    const {service, method, requestType, args} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let serviceInstance = AppContext.getInstance().getService(service);


    const member = yield call({context: memberService, fn: memberService.signin}, signinId, signinPw);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(SigninActions.requestSuccess(member));
  } catch (e) {
    yield put(SigninActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

function* watchAsyncRequest(): SagaIterator {
  yield takeEvery(AsyncRequestActions.REQUEST, request);
}

const sagaWatchers: SagaWatcher[] = [watchSignin];

export default sagaWatchers;
